require "import"
import "android.app.*"
import "android.content.*"
import "android.media.*"
import "android.os.*"
import "android.telephony.*"
import "android.net.*"
import "android.provider.Settings"
import "android.widget.*"
import "android.view.*"
import "android.util.*"

local prankcall = {}

local context = activity or service
local vibe = context.getSystemService(Context.VIBRATOR_SERVICE)
local ringtoneUri = RingtoneManager.getActualDefaultRingtoneUri(context, RingtoneManager.TYPE_RINGTONE)
local ringtone = RingtoneManager.getRingtone(context, ringtoneUri)
local handler = Handler(Looper.getMainLooper())

local vibing = false
local vibPattern = {0, 9000, 4000} -- Not used directly but here if needed
local audio = context.getSystemService(Context.AUDIO_SERVICE)

function prankcall.stopEverything()
  pcall(function()
    if ringtone and ringtone.isPlaying() then
      ringtone.stop()
    end
  end)
  handler.removeCallbacksAndMessages(handler, nil)
  if vibe then vibe.cancel() end
end

function prankcall.start()
  -- Start ringtone
  if ringtone then
    ringtone.setLooping(true)
    ringtone.play()
  end

  -- Start vibrating in a loop
  vibing = true
  local function vibrateLoop()
    if not vibing then return end
    if vibe then vibe.vibrate(9000) end
    handler.postDelayed(Runnable(vibrateLoop), 13000)
  end
  handler.post(Runnable(vibrateLoop))

  -- Build fake call dialog
  local builder = AlertDialog.Builder(context)
  builder.setTitle("Incoming Call")
  builder.setMessage("Unknown number")
  builder.setCancelable(false)

  builder.setPositiveButton("Answer", DialogInterface.OnClickListener{
    onClick = function(dialog, which)
      prankcall.stopEverything()

      -- Open dialer
      local intent = Intent(Intent.ACTION_DIAL)
      intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
      context.startActivity(intent)

      -- Speaker OFF (earpiece mode)
      audio.setSpeakerphoneOn(false)

      -- Reset after 10s
      handler.postDelayed(Runnable(function()
        audio.setSpeakerphoneOn(true)
      end), 10000)
    end
  })

  builder.setNegativeButton("Decline", DialogInterface.OnClickListener{
    onClick = function(dialog, which)
      prankcall.stopEverything()
    end
  })

  builder.show()
end

return prankcall